#include <mpi.h>
#include <stdio.h>
#include <string.h>
 
#define SERVER 0
#define TAG 2

int main(int argc, char **argv) {

	int my_rank, world_size; 
	int destination=SERVER, source;
	int tag=TAG, length;
	MPI_Status status;

	MPI_Init(&argc, &argv); 

	MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
	MPI_Comm_size(MPI_COMM_WORLD, &world_size);

	double start = -1.0, end = 1.0;
	double process_width = (end - start) / world_size;

	//calculate pi
	double xlow, xhigh;
	xlow = start + process_width * my_rank;
	xhigh = xlow + process_width;

	const int intervals = 100000;
	double x1, x2, y1, y2;
	double sub_area, process_area, subwidth;
	subwidth = proccess_width / intervals;

	process_area = 0.0;

	for (i = 0; i < intervals; i++) {
		// calculate x1, x2
		x1 = xlow + i * subwidth; // Boo!
		x2 = x1 + subwidth;
		//printf("Interval: %d; x1: %f; x2: %f\n", i, x1, x2);

		y1 = sqrt(1 - x1*x1);
		y2 = sqrt(1 - x2*x2);

		// calculate subinterval's area
		sub_area = (y1+y2) * subwidth * 0.5;

		// accumulate interval areas
		process_area += sub_area;
	}

	

	pi *= 2;
	printf("** PI **: %1.15f\n", pi);


	if (my_rank != SERVER) { // Client Section
	
	} else { // Server Section


	}

	MPI_Finalize();
} 
